import React from 'react';
export function createProvider(init, Provider, initialState) {
    return class RLProvider extends React.Component {
        constructor(props) {
            super(props);
            this.mounted = true;
            this.state = initialState;
            const setState = (state, callback) => {
                if (!this.mounted) {
                    return;
                }
                this.setState(state, callback);
            };
            init(() => this.state, setState);
        }
        componentWillUnmount() {
            this.mounted = false;
        }
        render() {
            const { children } = this.props;
            return (React.createElement(Provider, { value: this.state }, typeof children === 'function'
                ? children(this.state)
                : children));
        }
    };
}
